// HTTPSockTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "HTTPSockTest.h"
#include "HTTPSockTestDlg.h"
#include "InitSerial.h"
#include "Services.h"
#include <fstream.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BOOL done, tags, qrz;
CWinThread* pMyThread;
int port,baudrate;
CString callsign,ssid,tnc,proxy,digicallsign,digissid;
HANDLE hCom;
DCB dcb;

char kisson[60];
unsigned char persist[]={2,255,3,0};
unsigned char kissoff[]= {192,255,192};
unsigned char FEND[]={192};
unsigned char DATA[]={0};
BOOL fSuccess, MissingService;
DWORD dwW;
unsigned char textin[1300];
char xfile[128];

CString texts,www,url,param;
CString startstr, stopstr;

struct servicetype
{
	CString key;
	CString url;
	CString getstart;
	CString getstop;
} service[200];  
int servicenum;



void Xmit(CString indata){

unsigned char m_DataBuf[255];
unsigned char FEND[]={192};
unsigned char DATA[]={0};
int i,j,NumBytes,offset;
unsigned char myhead1[]= {144,168,168,160,64,64,96,64,64,64,64,64,64,96};  //packet header
unsigned char digi[] = {32,32,32,32,32,32,61};
unsigned char myhead2[] = {3,240};
		
//		while (m_DataBuf[NumBytes] != 0x00) (NumBytes++);
		NumBytes = indata.GetLength();
		for (i = 0;i<NumBytes;i++) (m_DataBuf[i] = indata.GetAt(i));
		for (i=0;i<NumBytes;i++){
			switch (m_DataBuf[i]){
			case 0xC0:
				for (j=NumBytes;j>i;j--) (m_DataBuf[j+1] = m_DataBuf[j]);  //stuff extra byte
				m_DataBuf[i] = 219;
				m_DataBuf[i+1] = 220;
				NumBytes++;
				break;
			case 0xDB:
				for (j=NumBytes;j>i;j--) (m_DataBuf[j+1] = m_DataBuf[j]);
				m_DataBuf[i] = 219;
				m_DataBuf[i+1] = 221;
				NumBytes++;
				break;
			}//end of case
		} //end of for

//-------Get the AX.25 Header----------	
		while (callsign.GetLength() <6) (callsign+= " ");//pad with spaces
	    for (i=7;i<13;i++) (myhead1[i] = (callsign.GetAt(i-7))<<1);// put callsign in myhead
		while (digicallsign.GetLength() <6) (digicallsign+= " ");//pad with spaces
		for (i=0;i<6;i++){
			(digi[i] = (digicallsign.GetAt(i))<<1);// put callsign in myhead
		}
		digi[6] = (digissid.GetAt(0)<<1) +1;
		if (digi[0] == ' ') (myhead1[13]=(ssid.GetAt(0)<<1) + 1);  //Add the SSID to the callsign
			else myhead1[13]=(ssid.GetAt(0)<<1);

//-------Transmit the Data--------------
		offset = 0;
		while (offset < NumBytes) {
			fSuccess = WriteFile(hCom,&FEND,1,&dwW,NULL);
			WriteFile(hCom,&DATA,1,&dwW,NULL);
	  		WriteFile(hCom,&myhead1,14,&dwW,NULL);
			if (digi[0] !=' '){
			   (WriteFile(hCom,&digi,7,&dwW,NULL));
			}//transmit the path if it isn't 0's
			
			WriteFile(hCom,&myhead2,2,&dwW,NULL);
			for (i = 0;i < 256;i++){
				if ((i+offset) < NumBytes) (WriteFile(hCom,&m_DataBuf[i+offset],1,&dwW,NULL));
			}
			offset = offset+i;
			fSuccess= WriteFile(hCom,&FEND,1,&dwW,NULL);
			Sleep(2000);
		}

}

//---------Worker Thread that runs the serial port-------
UINT MyWorkerThread(LPVOID pStuff)       
{
unsigned char ob,ob2;

unsigned char head[16];
DWORD dwR;
char cr = 0x0d;
int i, numchar,loc1,loc2,loc3,loc4;
char SID;
BOOL fSuccess;
CString incall,tempcall,user,outtype,ending;	
MSG msg;
UINT hostport;

CHTTPSockTestDlg *pDlg = (CHTTPSockTestDlg *) pStuff;
    
while (TRUE){
		ob =ob2=0;
		for (i=0;i<1300;i++) (textin[i] = 0x00);  //fill the array with 0's
		do{
			fSuccess=ReadFile(hCom,&ob,1,&dwR,NULL);//throw out all the bytes until you get to C0
			loc1 = GetLastError();
		} while (ob!=0xC0);
		ReadFile(hCom,&ob,1,&dwR,NULL);      
		(ReadFile(hCom,&head,16,&dwR,NULL)); 
		user.Empty();
		for (i=7;i<13;i++){
			user +=head[i]>>1;  //get the user's callsign
		}
		i = 0;  //set i to beginning of textin buffer
		do{
			ReadFile(hCom,&ob,1,&dwR,NULL);	
			if (ob == 0xDB){					//if the byte is FESC, check to see if substitution is needed
				ReadFile(hCom,&ob2,1,&dwR,NULL);	
				switch (ob2)
				{
					case 0xDC : 
						textin[i++] = 0xC0;break;
					case 0xDD :
						textin[i++] = 0xDB;break;
					default :
						textin[i++] = ob;
						textin[i++] = ob2;
					} //end of switch
			} //end of if
			else {
				if (ob != 0xc0) (textin[i++] = ob);
			}	
		}while ((ob != 0xC0) && (i<255));    //don't let the array overrun
		
		numchar = i;
		outtype.Empty();
		for (i=0;i<4;i++){
			outtype +=textin[i];
		}
		outtype.MakeUpper();
		tags = FALSE;qrz = FALSE;
		if (outtype == "HTML") (tags = TRUE);  //if html, send the tags too
		incall.Empty();
		for (i=0;i<6;i++){
			incall += head[i]>>1;
		}
		incall.TrimRight();
		SID = (head[6]/2);
		if (SID != 0x30) incall = incall+"-"+SID;

		tempcall = callsign;
		
		tempcall.TrimRight();
		if (ssid != "0") (tempcall = tempcall + "-" +ssid);
		if ((incall.Compare(tempcall) == 0) & (numchar < 254)){  //only service if it is sent to this server
			texts = textin;
			servicenum =-1;
			for (i=0;i<200;i++){			//find the service that matches
				if ((texts.Find(service[i].key)> -1) & (service[i].key != "")){
					servicenum = i;
					break;
				}
			}
			MissingService = FALSE;
			if ((servicenum == -1) & (texts.Find("html://") != 0) & (texts.Find("http://") != 0)){
					(Xmit(user+": Service not found."+cr));  //report that service has not been found.
					MissingService = TRUE;
			}
			  if (servicenum > -1){     // do this if this is a service request
				loc2 = service[servicenum].url.Find("/");
				www = service[servicenum].url.Left(loc2);    //here's the website
				url = service[servicenum].url.Mid(loc2,service[servicenum].url.GetLength()-loc2);  //here's the page (need to do parameter substitutions)

				loc1 = url.Find("%1");  //process the first parameter
				if (loc1 > -1){
					loc2 = texts.Find("://");loc2 = loc2 +3;
					loc3 = texts.Find("%"); 
					if (loc3 < 0) (loc3 = 500);
					url = url.Left(loc1)+texts.Mid(loc2,loc3-loc2)+url.Mid(loc1+2);
					texts = texts.Mid(loc3+1); //delete all the input line up to "%"
				}

				loc1 = url.Find("%2");   //process the second parameter
				if (loc1 > -1){
					loc3 = texts.Find("%"); 
					if (loc3 < 0) (loc3 = 500);
					url = url.Left(loc1)+texts.Left(loc3)+url.Mid(loc1+2);
					texts = texts.Mid(loc3+1); //delete all the input line up to "%"
				}

				loc1 = url.Find("%3");   //process the third parameter
				if (loc1 > -1){
					loc3 = texts.Find("%"); 
					if (loc3 < 0) (loc3 = 500);
					url = url.Left(loc1)+texts.Left(loc3)+url.Mid(loc1+2);
					texts = texts.Mid(loc3+1); //delete all the input line up to "%"
				}
				loc1 = url.Find("%4");   //process the fourth parameter
				if (loc1 > -1){
					loc3 = texts.Find("%"); 
					if (loc3 < 0) (loc3 = 500);
					url = url.Left(loc1)+texts.Left(loc3)+url.Mid(loc1+2);
					texts = texts.Mid(loc3+1); //delete all the input line up to "%"
				}
				startstr = service[servicenum].getstart;
				stopstr = service[servicenum].getstop;
			}

			if ((texts.Find("html://") == 0) | (texts.Find("http://") == 0)){   //process if looking for entire page
				servicenum = -1;   //set servicenum back to -1
				loc1 = texts.Find("//");   //find the beginning of the server name
				texts = texts.Right(texts.GetLength()-7);
				loc2 = texts.Find('/');  //find the beginning of the url
				if (loc2 != -1){     //what to do if a specific page is requested
					www = texts.Left(loc2);
					url = texts.Mid(loc2,texts.GetLength()-loc2-1);
					i = texts.GetAt(texts.GetLength()-3);
					if (texts.GetAt(texts.GetLength()-2) != '/'){
						loc4 = texts.ReverseFind('/');
						ending = texts.Mid(loc4);
						if (ending.Find('.') < 0) (url += '/');  //add a slash at the end if there isn't one
					}
				}
				if (loc2 == -1) {
					www = texts.Left(texts.GetLength()-1);  //what to do if no specific web page is requested
					url = '/';
				}//end of if
			}//end of if (texts...





			if (pDlg->URLok(www) == FALSE){
				Xmit(user+": That page not allowed."+cr);
			}else {
				loc2 = url.Find(' ');
				while (loc2 != -1) {
					url.SetAt(loc2,'+');   //replace spaces with plus signs in the URL
					loc2 = url.Find(' ');
				}
				hostport = 80;
				if (!proxy.IsEmpty()){
					url = "http://"+www+url;   //execute this code if going through a proxy server
					www = proxy;
					hostport = 8080;
				}
				
				
				
				if (MissingService == FALSE){
					SimpleHTTPClientSocket *pSocket = new SimpleHTTPClientSocket(url);  //call the socket
					pSocket->Create();
					pSocket->AsyncSelect(FD_CONNECT | FD_READ | FD_CLOSE);
					if (!pSocket->Connect(www, 80)) {   //connect
						int error = GetLastError();
						if (error != WSAEWOULDBLOCK){
							Xmit("Can't Connect "+ www+cr);   //no connection inform user
						}
						else {
							user.TrimRight();
							Xmit("OK "+user+": "+www+url+cr); 
							while (GetMessage(&msg, NULL, 0, 0)){   //wait for page to be received before allowing another request
								TranslateMessage(&msg);
								DispatchMessage(&msg);
							}//end of while
						}//end of else
						if (servicenum > -1) (Xmit(cr));
						Xmit(0x1A);  //send cntl-Z to indicate page is done
					}//end of if
				}//end of if MissingService
			}//end of else
		}//end of if 

}//end of while (TRUE)


AfxEndThread(1);
return 0;
}



/////////////////////////////////////////////////////////////////////////////
// CHTTPSockTestDlg dialog

CHTTPSockTestDlg::CHTTPSockTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHTTPSockTestDlg::IDD, pParent)
{
CWinApp* pApp = AfxGetApp();
	port = pApp->GetProfileInt("HW2","port",12);
	callsign = pApp->GetProfileString("HW2","callsign","NOCALL");   //get parameters from the registry
	digicallsign = pApp->GetProfileString("HW2","digicallsign","      ");
	proxy = pApp->GetProfileString("HW2","proxy","");
	ssid = pApp->GetProfileString("HW2","ssid","0");
	digissid = pApp->GetProfileString("HW2","digissid","0");
	baudrate = pApp->GetProfileInt("HW2","baudrate",1200);
	tnc = pApp->GetProfileString("HW2","tnc","TAPR");
	if (callsign == "NOCALL"){
		InitSerial dInitSerial;
		(dInitSerial.DoModal());
		port = pApp->GetProfileInt("HW2","port",12);
		callsign = pApp->GetProfileString("HW2","callsign","NOCALL");   //get parameters from the registry
		digicallsign = pApp->GetProfileString("HW2","digicallsign","      ");   //get parameters from the registry
		ssid = pApp->GetProfileString("HW2","ssid","0");
		digissid = pApp->GetProfileString("HW2","digissid","0");
		baudrate = pApp->GetProfileInt("HW2","baudrate",1200);
		tnc = pApp->GetProfileString("HW2","tnc","TAPR");
	}
	int i;
	for (i=0;i<200;i++){
		service[i].key = "";
		service[i].url = "";
		service[i].getstart  = "";
		service[i].getstop = "";
	}

		if (tnc.Left(4) == "TAPR") strcpy(kisson,"KISS ON\rRESTART\r");
		if (tnc.Left(4) == "Kant") strcpy(kisson,"INTface KISS\n\rRESET\n\r");
		if (tnc.Left(4) == "Pico") strcpy(kisson,"\r\n\r\nmkiss\r\n");
		if (tnc.Left(4) == "PK-2") strcpy(kisson,"\n\rKISS ON\n\r");
		if (tnc.Left(4) == "PK-8") strcpy(kisson,"CONMODE TRANS\n\rPPERSIST ON\\nrRAW ON\n\rHPOLL OFF\n\rKISS ON\n\rRESTART\n\r");
		if (tnc.Left(4) == "Old K") strcpy(kisson,"KISSMODE ON\n\rRESET\n\r");

		switch(port) {
			case 0: hCom = CreateFile("COM1", GENERIC_READ | GENERIC_WRITE, 0,NULL,OPEN_EXISTING,0,NULL);break;
			case 1: hCom = CreateFile("COM2", GENERIC_READ | GENERIC_WRITE, 0,NULL,OPEN_EXISTING,0,NULL);break;
			case 2: hCom = CreateFile("COM3", GENERIC_READ | GENERIC_WRITE, 0,NULL,OPEN_EXISTING,0,NULL);break;
			case 3: hCom = CreateFile("COM4", GENERIC_READ | GENERIC_WRITE, 0,NULL,OPEN_EXISTING,0,NULL);break;
			case 4: hCom = CreateFile("COM5", GENERIC_READ | GENERIC_WRITE, 0,NULL,OPEN_EXISTING,0,NULL);break;
			case 5: hCom = CreateFile("COM6", GENERIC_READ | GENERIC_WRITE, 0,NULL,OPEN_EXISTING,0,NULL);break;
			case 6: hCom = CreateFile("COM7", GENERIC_READ | GENERIC_WRITE, 0,NULL,OPEN_EXISTING,0,NULL);break;
			case 7: hCom = CreateFile("COM8", GENERIC_READ | GENERIC_WRITE, 0,NULL,OPEN_EXISTING,0,NULL);break;

			}
	
		fSuccess = GetCommState(hCom, &dcb);
		dcb.BaudRate = baudrate;
		dcb.ByteSize = 8;
		dcb.Parity = NOPARITY;
		dcb.StopBits = ONESTOPBIT;
		fSuccess = SetCommState(hCom, &dcb);
	    Sleep(2000);

		fSuccess = WriteFile(hCom,&kisson,60,&dwW,NULL);//put tnc in kiss mode
		WriteFile(hCom,&FEND,1,&dwW,NULL);    
		WriteFile(hCom,&persist,4,&dwW,NULL);  //set persist to never wait.
		WriteFile(hCom,&FEND,1,&dwW,NULL);
		pMyThread = AfxBeginThread(MyWorkerThread,this);
	
	//{{AFX_DATA_INIT(CHTTPSockTestDlg)
	m_AddAllowedURL = _T("");
	m_BannedURL = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CHTTPSockTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHTTPSockTestDlg)
	DDX_Control(pDX, IDC_EDIT2, m_burl);
	DDX_Control(pDX, IDC_LIST2, m_banned);
	DDX_Control(pDX, IDC_EDIT1, m_aurl);
	DDX_Control(pDX, IDC_LIST1, m_allowed);
	DDX_Text(pDX, IDC_EDIT1, m_AddAllowedURL);
	DDX_Text(pDX, IDC_EDIT2, m_BannedURL);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHTTPSockTestDlg, CDialog)
	//{{AFX_MSG_MAP(CHTTPSockTestDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnAddAllowed)
	ON_BN_CLICKED(IDC_BUTTON2, OnDeleteAllowed)
	ON_LBN_DBLCLK(IDC_LIST1, OnDblclkList1)
	ON_BN_CLICKED(IDC_BUTTON3, OnAddBanned)
	ON_BN_CLICKED(IDC_BUTTON4, OnDeleteBanned)
	ON_LBN_DBLCLK(IDC_LIST2, OnDblclkList2)
	ON_BN_CLICKED(IDC_BUTTON5, OnChangePort)
	ON_BN_CLICKED(IDC_BUTTON6, OnManageServices)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()






/////////////////////////////////////////////////////////////////////////////
// CHTTPSockTestDlg message handlers

BOOL CHTTPSockTestDlg::OnInitDialog()
{
	int i;
	CDialog::OnInitDialog();
	
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	ifstream inf("allowed.txt");
	while (inf){
		inf.getline(xfile,128);
		m_allowed.AddString(xfile);
	}
	inf.close();

	m_allowed.DeleteString(0);
	ifstream iinf("banned.txt");
	while (iinf){
		iinf.getline(xfile,128);
		m_banned.AddString(xfile);
	}
	iinf.close();
	m_banned.DeleteString(0);

	ifstream iiinf("services.txt");
	for (i=0;i<200;i++){
		iiinf.getline(xfile,128);
		service[i].key=xfile;
		iiinf.getline(xfile,128);
		service[i].url=xfile;
		iiinf.getline(xfile,128);
		service[i].getstart=xfile;
		iiinf.getline(xfile,128);
		service[i].getstop=xfile;
		
	}




//	m_allowed.SetHorizontalExtent(300);
//	m_banned.SetHorizontalExtent(300);
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CHTTPSockTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CHTTPSockTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}



BOOL CHTTPSockTestDlg::DestroyWindow() 
{

	    WriteFile(hCom,&kissoff,3,&dwW,NULL);
		CloseHandle(hCom);
	return CDialog::DestroyWindow();
}

void CHTTPSockTestDlg::OnAddAllowed() 
{
	UpdateData();
	m_allowed.AddString(m_AddAllowedURL);
	m_aurl.SetWindowText("");


}

void CHTTPSockTestDlg::OnDeleteAllowed() 
{
	m_allowed.DeleteString(m_allowed.GetCurSel());	
}

void CHTTPSockTestDlg::OnDblclkList1() 
{
	m_allowed.DeleteString(m_allowed.GetCurSel());
	
}

void CHTTPSockTestDlg::OnAddBanned() 
{
	UpdateData();
	m_banned.AddString(m_BannedURL);
	m_burl.SetWindowText("");
	
}

void CHTTPSockTestDlg::OnDeleteBanned() 
{
	m_banned.DeleteString(m_banned.GetCurSel());	
}

void CHTTPSockTestDlg::OnDblclkList2() 
{
	m_banned.DeleteString(m_banned.GetCurSel());
	
}

void CHTTPSockTestDlg::OnCancel() 
{

	FILE *fp;
	int i;
	char xfile[130];
	char xxfile[130];
	m_allowed.GetText(0,xxfile);
	fp = fopen("allowed.txt","w");
	for (i = 0; i< m_allowed.GetCount();i++) {  //write the allowed list
		m_allowed.GetText(i,xfile);
		fputs(xfile,fp);
		fputs("\n",fp);
	}
	fclose(fp);
	m_banned.GetText(0,xxfile);
	fp = fopen("banned.txt","w");
	for (i = 0; i< m_banned.GetCount();i++) {  //write the banned list
		m_banned.GetText(i,xfile);
		fputs(xfile,fp);
		fputs("\n",fp);
	}
	fclose(fp);
	fp =fopen("services.txt","w");  //write the services data
	for (i =0;i<200;i++){
		fputs(service[i].key,fp);
		fputs("\n",fp);
		fputs(service[i].url,fp);
		fputs("\n",fp);
		fputs(service[i].getstart,fp);
		fputs("\n",fp);
		fputs(service[i].getstop,fp);
		fputs("\n",fp);
	}
	fclose(fp);
	CDialog::OnCancel();
}
void CHTTPSockTestDlg::OnOK()
{
//	CDialog::OnOK();
}

void CHTTPSockTestDlg::OnChangePort() 
{
int result;
	
				InitSerial dserial;
				result = dserial.DoModal();
				if (result == 1) (AfxMessageBox("Port Changes do Not Become Effective\nUntil the Next Time the Program is Run.",MB_OK,0));

	
}

void CHTTPSockTestDlg::OnManageServices() 
{
				Services dservices;
				dservices.DoModal();	
}
