// HTTPSockTestDlg.h : header file
//

#if !defined(AFX_HTTPSOCKTESTDLG_H__E7F07446_C98E_11D2_A8CB_00A024731215__INCLUDED_)
#define AFX_HTTPSOCKTESTDLG_H__E7F07446_C98E_11D2_A8CB_00A024731215__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// CHTTPSockTestDlg dialog
#include "SimpleHTTPClientSocket.h"
class CHTTPSockTestDlg : public CDialog
{
// Construction
public:
	CHTTPSockTestDlg(CWnd* pParent = NULL);	// standard constructor

	BOOL URLok(CString url){
	
		int i,len,temp;
		CString str1, str2, str3;
		BOOL doit;
		doit = FALSE;
		m_allowed.GetText(0,str1);
		if ((str1 == "*") & (str1.GetLength() == 1)) (doit = TRUE); //allows all pages
		for (i=0;i< m_allowed.GetCount();i++){  //see if the url is on the allowed list
			m_allowed.GetText(i,str1);
			len = str1.GetLength();
			temp = url.GetLength();
			if (str1.GetAt(0) !='*'){
				if (len< url.GetLength()) (str2 = url.Left(len));
					else str2 = url;
				if (str1 == str2) (doit = TRUE);
			}
			if (str1.GetAt(0) == '*'){
				str1 = str1.Mid(1);
				if (len< url.GetLength()) (str2 = url.Right(len-1));
					else str2 = url;
				if (str1 == str2) (doit = TRUE);
			}
		}
		for (i=0;i< m_banned.GetCount();i++){  //see if the url is on the banned list
			m_banned.GetText(i,str1);
			len = str1.GetLength();
			temp = url.GetLength();
			if (str1.GetAt(0) !='*'){
				if (len< url.GetLength()) (str2 = url.Left(len));
					else str2 = url;
				if (str1 == str2) (doit = FALSE);
			}
			if (str1.GetAt(0) == '*'){
				str1 = str1.Mid(1);
				if (len< url.GetLength()) (str2 = url.Right(len-1));
					else str2 = url;
				if (str1 == str2) (doit = FALSE);
			}
		}
		
		
		return doit;
	}

// Dialog Data
	//{{AFX_DATA(CHTTPSockTestDlg)
	enum { IDD = IDD_HTTPSOCKTEST_DIALOG };
	CEdit	m_burl;
	CListBox	m_banned;
	CEdit	m_aurl;
	CListBox	m_allowed;
	CString	m_HostName;
	CString	m_Request;
	CString	m_AddAllowedURL;
	CString	m_BannedURL;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHTTPSockTestDlg)
	public:
	virtual BOOL DestroyWindow();
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CHTTPSockTestDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnAddAllowed();
	afx_msg void OnDeleteAllowed();
	afx_msg void OnDblclkList1();
	afx_msg void OnAddBanned();
	afx_msg void OnDeleteBanned();
	afx_msg void OnDblclkList2();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnChangePort();
	afx_msg void OnManageServices();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_HTTPSOCKTESTDLG_H__E7F07446_C98E_11D2_A8CB_00A024731215__INCLUDED_)
