// Services.cpp : implementation file
//

#include "stdafx.h"
#include "HTTPSockTest.h"
#include "Services.h"
#include "AddSource.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
CString addkey;
int serv;

extern struct servicetype
{
	CString key;
	CString url;
	CString getstart;
	CString getstop;
} service[200]; 
/////////////////////////////////////////////////////////////////////////////
// Services dialog


Services::Services(CWnd* pParent /*=NULL*/)
	: CDialog(Services::IDD, pParent)
{
	//{{AFX_DATA_INIT(Services)
	m_Keyword = _T("");
	//}}AFX_DATA_INIT
}




void Services::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(Services)
	DDX_Control(pDX, IDC_EDIT5, m_stop);
	DDX_Control(pDX, IDC_EDIT4, m_fetch);
	DDX_Control(pDX, IDC_EDIT1, m_url);
	DDX_Control(pDX, IDC_COMBO2, m_KeywordBox);
	DDX_CBString(pDX, IDC_COMBO2, m_Keyword);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(Services, CDialog)
	//{{AFX_MSG_MAP(Services)
	ON_BN_CLICKED(IDC_BUTTON1, OnAddService)
	ON_CBN_SELCHANGE(IDC_COMBO2, OnChangeKW)
	ON_BN_CLICKED(IDC_BUTTON2, OnDeleteService)
	ON_EN_KILLFOCUS(IDC_EDIT1, OnKillFocusUrl)
	ON_EN_KILLFOCUS(IDC_EDIT4, OnKillFocusFetch)
	ON_EN_KILLFOCUS(IDC_EDIT5, OnKillFocusStop)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL Services::OnInitDialog()
{
	CDialog::OnInitDialog();

	serv=0;
	while ((serv < 200) & (service[serv].key != "")){
		m_KeywordBox.AddString(service[serv].key);
		serv++;
	}
	
	m_KeywordBox.SetCurSel(0);
	UpdateData();
	serv = 0;
	while ((serv < 200) & (service[serv].key != m_Keyword)){
		serv++;
	}
	m_url.SetWindowText(service[serv].url);
	m_fetch.SetWindowText(service[serv].getstart);
	m_stop.SetWindowText(service[serv].getstop);
	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// Services message handlers

void Services::OnAddService()   //call the dialog box to add a new service
{
				AddSource dsource;
				dsource.DoModal();
				if (addkey != "") (m_KeywordBox.AddString(addkey));

}

void Services::OnChangeKW()   //Does this when new Keyword is selected from the list
{

	UpdateData();
	
	serv = 0;
	while ((serv < 200) & (service[serv].key != m_Keyword)){
		serv++;
	}
	m_url.SetWindowText(service[serv].url);
	m_fetch.SetWindowText(service[serv].getstart);
	m_stop.SetWindowText(service[serv].getstop);

}

void Services::OnDeleteService() 
{
	while ((serv < 200) & (service[serv].key != m_Keyword)){
		serv++;
	}
	while (serv<199){
		service[serv].key = service[serv+1].key;
		service[serv].url = service[serv+1].url;
		service[serv].getstart = service[serv+1].getstart;
		service[serv].getstop = service[serv+1].getstop;
		serv++;
	}
	service[199].key = "";
	service[199].url = "";
	service[199].getstart = "";
	service[199].getstop = "";	
	m_KeywordBox.DeleteString(m_KeywordBox.GetCurSel());
	serv =0;
	m_KeywordBox.SetCurSel(0);
	m_url.SetWindowText(service[0].url);
	m_fetch.SetWindowText(service[0].getstart);
	m_stop.SetWindowText(service[0].getstop);
	UpdateWindow();
}

void Services::OnKillFocusUrl() 
{
	  m_url.GetWindowText(service[serv].url);     //allows editing of url
	
}

void Services::OnKillFocusFetch() 
{
	m_fetch.GetWindowText(service[serv].getstart);  //allows editing of fetch start
	
}

void Services::OnKillFocusStop() 
{
	m_stop.GetWindowText(service[serv].getstop);	//allows editing of fetch stop
}
