// FindemDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Findem.h"
#include "FindemDlg.h"
#include "serial.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
HANDLE hCom;
int port,baudrate,tnc;
CString server,callsign;

/////////////////////////////////////////////////////////////////////////////
// CFindemDlg dialog

UINT MyWorkerThread(LPVOID pStuff)       
{
unsigned char ob, ob2;
unsigned char head[16];
unsigned char textin[300];
CString textstr,leftover,textout;
int i;
DWORD dwR;
BOOL fSuccess;
	CFindemDlg *pDlg = (CFindemDlg *) pStuff;
	leftover.Empty();
	while (TRUE){

		ob =ob2=0;
		for (i=0;i<300;i++) (textin[i] = 0x00);  //fill the array with 0's
		do{
			fSuccess=ReadFile(hCom,&ob,1,&dwR,NULL);//throw out all the bytes until you get to C0
		} while (ob!=0xC0);
		do{
			fSuccess=ReadFile(hCom,&ob,1,&dwR,NULL);
		} while(ob != 0x00);
		ReadFile(hCom,&head,16,&dwR,NULL); 
		i = 0;  //set i to beginning of textin buffer
		do{
			ReadFile(hCom,&ob,1,&dwR,NULL);	
			if (ob == 0xDB){					//if the byte is FESC, check to see if substitution is needed
				ReadFile(hCom,&ob2,1,&dwR,NULL);	
				switch (ob2)
				{
					case 0xDC : 
						textin[i++] = 0xC0;break;
					case 0xDD :
						textin[i++] = 0xDB;break;
					default :
						textin[i++] = ob;
						textin[i++] = ob2;
					} //end of switch
			} //end of if
			else {
				if (ob != 0xC0) (textin[i++] = ob);
			}	
		}while ((ob != 0xC0) && (i<255));    //don't let the array overrun
		textstr = leftover+textin;
		leftover.Empty();
		if (textstr.GetAt(0) != 0x1A){
			i = 0;
			while (i >= 0){
				textstr = leftover+textstr;
				i = textstr.Find(0x0D);			//look for a cr
				if (i >=0) (textout = textstr.Left(i));		//textout is all text to left of cr
					else (textout = textstr);
				if (textout.GetLength() > 80){	//is textout longer than 70
					pDlg->PostText(textout.Left(80)); //post the first 70
					textstr = textstr.Mid(80);		//what hasn't been posted	
					i=0;					//make sure this loops again
					leftover.Empty();
				}
				else{				//if text to left of cr is less than 70 
					if (i<0) {
						leftover = textstr.Mid(i+1);
					}
					textstr = textstr.Mid(i+1);
					if (i>=0){
						pDlg->PostText(textout);
					}
				}//end of else
			}//end of while	
		}//end of if
	}//end of while true
	AfxEndThread(1);
	return 0;
}		


CFindemDlg::CFindemDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFindemDlg::IDD, pParent)
{
	

	char kisson[60];
	BOOL fSuccess;
	DCB dcb;
	unsigned char FEND[]={192};
	unsigned char persist[]={2,255,3,0};
	DWORD dwW;
	CWinThread* pMyThread;
	int speed;

	
	//{{AFX_DATA_INIT(CFindemDlg)
	m_request = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);


	CWinApp* pApp = AfxGetApp();
	port = pApp->GetProfileInt("UITerm","port",12);
	server = pApp->GetProfileString("UITerm","server","NOCALL");   //get parameters from the registry
	callsign = pApp->GetProfileString("UITerm","callsign","NOCALL");
	baudrate = pApp->GetProfileInt("UITerm","baudrate",1200);
	tnc = pApp->GetProfileInt("UITerm","tnc",0);
	if (server == "NOCALL"){
		serial dSerial;
		(dSerial.DoModal());
	
		port = pApp->GetProfileInt("UITerm","port",12);
		server = pApp->GetProfileString("UITerm","server","NOCALL");   //get parameters from the registry
		callsign = pApp->GetProfileString("UITerm","callsign","NOCALL");
		baudrate = pApp->GetProfileInt("UITerm","baudrate",1200);
		tnc = pApp->GetProfileInt("UITerm","tnc",0);
	
	
	}
	server.MakeUpper();
	callsign.MakeUpper();

	if (tnc == 0) strcpy(kisson,"KISS ON\rRESTART\r");
	if (tnc == 1) strcpy(kisson,"INTface KISS\n\rRESET\n\r");
	if (tnc == 2) strcpy(kisson,"mkiss\n\r");
	if (tnc == 3) strcpy(kisson,"KISSMODE ON\n\rRESET\n\r");
	if (tnc == 4) strcpy(kisson,"KISS ON\n\r");
	if (tnc == 5) strcpy(kisson,"CONMODE TRANS\n\rPPERSIST ON\n\rRAW ON\n\rHPOLL OFF\n\rKISS ON\n\rRESTART\n\r");
	
	switch(port) {
		case 0: hCom = CreateFile("COM1", GENERIC_READ | GENERIC_WRITE, 0,NULL,OPEN_EXISTING,0,NULL);break;
		case 1: hCom = CreateFile("COM2", GENERIC_READ | GENERIC_WRITE, 0,NULL,OPEN_EXISTING,0,NULL);break;
		case 2: hCom = CreateFile("COM3", GENERIC_READ | GENERIC_WRITE, 0,NULL,OPEN_EXISTING,0,NULL);break;
		case 3: hCom = CreateFile("COM4", GENERIC_READ | GENERIC_WRITE, 0,NULL,OPEN_EXISTING,0,NULL);break;
		case 4: hCom = CreateFile("COM5", GENERIC_READ | GENERIC_WRITE, 0,NULL,OPEN_EXISTING,0,NULL);break;
		case 5: hCom = CreateFile("COM6", GENERIC_READ | GENERIC_WRITE, 0,NULL,OPEN_EXISTING,0,NULL);break;
		case 6: hCom = CreateFile("COM7", GENERIC_READ | GENERIC_WRITE, 0,NULL,OPEN_EXISTING,0,NULL);break;
		case 7: hCom = CreateFile("COM8", GENERIC_READ | GENERIC_WRITE, 0,NULL,OPEN_EXISTING,0,NULL);break;
	}
	switch(baudrate){
		case 0: speed = 1200;break;
		case 1: speed = 2400;break;
		case 2: speed = 4800;break;
		case 3: speed = 9600;break;
		case 4: speed =19200;break;
	}
	fSuccess = GetCommState(hCom, &dcb);
	dcb.BaudRate = speed;
	dcb.ByteSize = 8;
	dcb.Parity = NOPARITY;
	dcb.StopBits = ONESTOPBIT;
	fSuccess = SetCommState(hCom, &dcb);


	fSuccess = WriteFile(hCom,&kisson,60,&dwW,NULL);//put tnc in kiss mode
	WriteFile(hCom,&FEND,1,&dwW,NULL);    
	WriteFile(hCom,&persist,4,&dwW,NULL);  //set persist to never wait.
	WriteFile(hCom,&FEND,1,&dwW,NULL);
	pMyThread = AfxBeginThread(MyWorkerThread,this);

}

void CFindemDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFindemDlg)
	DDX_Control(pDX, IDC_LIST1, m_result);
	DDX_Text(pDX, IDC_EDIT2, m_request);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFindemDlg, CDialog)
	//{{AFX_MSG_MAP(CFindemDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDOK, OnLookUp)
	ON_BN_CLICKED(IDC_BUTTON1, OnClearBuffer)
	ON_BN_CLICKED(IDC_BUTTON2, OnChangePort)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFindemDlg message handlers

BOOL CFindemDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	CClientDC dc(AfxGetMainWnd());
	int tester;
    tester = -dc.GetDeviceCaps(LOGPIXELSY);
	if (tester == -120){						//if system large font is on use this font for list box
	m_font2.CreateFont(18,0,0,0,FW_NORMAL,0,0,0,ANSI_CHARSET,OUT_STROKE_PRECIS,
		CLIP_STROKE_PRECIS,DRAFT_QUALITY,
		VARIABLE_PITCH | FF_SWISS,_T("Courier New"));
	}
	else
	m_font2.CreateFont(14,0,0,0,FW_NORMAL,0,0,0,ANSI_CHARSET,OUT_STROKE_PRECIS,
		CLIP_STROKE_PRECIS,DRAFT_QUALITY,
		VARIABLE_PITCH | FF_SWISS,_T("Courier New"));  //if system small font is on use this font for list box
	m_result.SetFont(&m_font2);             //font for frequency listbox	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFindemDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFindemDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CFindemDlg::OnLookUp()
{
unsigned char datac[200];
BOOL fSuccess;
DWORD dwW;
unsigned char cr = 0x0D;
unsigned char FEND[]={192};
unsigned char DATA[]={0};
int i,j,NumBytes,SID;
static unsigned char myhead[]= {144,168,168,160,64,64,96,64,64,64,64,64,64,97,3,240};  //packet header

		for (i=0;i<sizeof(datac);i++) (datac[i]=0x00);
		UpdateData();

		for (i =0;i<m_request.GetLength();i++) (datac[i] = m_request.GetAt(i));
		datac[i] = 0x0D;  //add cr at end
		NumBytes = m_request.GetLength()+1;
		for (i=0;i<NumBytes;i++){
			switch (datac[i]){
			case 0xC0:
				for (j=NumBytes;j>i;j--) (datac[j+1] = datac[j]);  //stuff extra byte
				datac[i] = 219;
				datac[i+1] = 220;
				NumBytes++;
				break;
			case 0xDB:
				for (j=NumBytes;j>i;j--) (datac[j+1] = datac[j]);
				datac[i] = 219;
				datac[i+1] = 221;
				NumBytes++;
				break;
			}//end of case
		}
		i= callsign.Find('-');
		if (i != -1) {
			SID = callsign.GetAt(i+1)-0x30;
			callsign = callsign.Left(i);
			myhead[13] = myhead[13] + (2*SID);
		}
		while (callsign.GetLength() <6) (callsign+= " ");//pad with spaces
	    for (i=7;i<13;i++) (myhead[i] = (callsign.GetAt(i-7))<<1);
		

		i = server.Find('-');
		if (i != -1) {
			SID = server.GetAt(i+1)-0x30;
			server = server.Left(i);
			myhead[6] = myhead[6] + (2*SID);
		}

		while (server.GetLength() <6) (server+= " ");//pad with spaces
	    for (i=0;i<6;i++) (myhead[i] = (server.GetAt(i))<<1);

		
		fSuccess = WriteFile(hCom,&FEND,1,&dwW,NULL);
		WriteFile(hCom,&DATA,1,&dwW,NULL);
	 	WriteFile(hCom,&myhead,16,&dwW,NULL);	
		for (i = 0;i < m_request.GetLength()+1;i++){
			WriteFile(hCom,&datac[i],1,&dwW,NULL);
		}
		fSuccess= WriteFile(hCom,&FEND,1,&dwW,NULL);
		Sleep(2000);
		

}






BOOL CFindemDlg::DestroyWindow() 
{


unsigned char kissoff[]= {192,255,192};
DWORD dwW;
	
	    WriteFile(hCom,&kissoff,3,&dwW,NULL);
		CloseHandle(hCom);
	return CDialog::DestroyWindow();
}


void CFindemDlg::OnClearBuffer() 
{
	m_result.ResetContent();
	m_result.UpdateWindow();
	
}

void CFindemDlg::OnChangePort() 
{

	serial dserial;
	int result = dserial.DoModal();
	if (result == 1) (AfxMessageBox("Port Changes do Not Become Effective\nUntil the Next Time the Program is Run.",MB_OK,0));
	
}
