// InitSerial.cpp : implementation file
//

#include "stdafx.h"
#include "Findem.h"
#include "InitSerial.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// InitSerial dialog


InitSerial::InitSerial(CWnd* pParent /*=NULL*/)
	: CDialog(InitSerial::IDD, pParent)
{
	//{{AFX_DATA_INIT(InitSerial)
	m_tnc = _T("");
	m_port = -1;
	m_call = _T("");
	m_ss = _T("");
	m_baudrate = _T("");
	//}}AFX_DATA_INIT
}


void InitSerial::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(InitSerial)
	DDX_Control(pDX, IDC_EDIT2, m_ssid);
	DDX_Control(pDX, IDC_EDIT1, m_callsign);
	DDX_CBString(pDX, IDC_COMBO2, m_tnc);
	DDX_Radio(pDX, IDC_RADIO1, m_port);
	DDX_Text(pDX, IDC_EDIT1, m_call);
	DDX_Text(pDX, IDC_EDIT2, m_ss);
	DDV_MaxChars(pDX, m_ss, 2);
	DDX_CBString(pDX, IDC_COMBO1, m_baudrate);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(InitSerial, CDialog)
	//{{AFX_MSG_MAP(InitSerial)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// InitSerial message handlers

void InitSerial::OnOK() 
{
extern int baudrate;
extern int port;
extern  CString callsign;
extern CString ssid;
CWinApp* pApp = AfxGetApp();



UpdateData();
m_callsign.GetWindowText(callsign);
callsign.MakeUpper();
m_ssid.GetWindowText(ssid);

baudrate = atoi(m_baudrate);
pApp->WriteProfileString("HW2","callsign",callsign); //write parameters into the registry
pApp->WriteProfileInt("HW2","port",m_port);
pApp->WriteProfileString("HW2","ssid",ssid);
pApp->WriteProfileString("HW2","tnc",m_tnc);
pApp->WriteProfileInt("HW2","baudrate",baudrate);	
	CDialog::OnOK();
}
