// serial.cpp : implementation file
//

#include "stdafx.h"
#include "Findem.h"
#include "serial.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// serial dialog


serial::serial(CWnd* pParent /*=NULL*/)
	: CDialog(serial::IDD, pParent)
{
	//{{AFX_DATA_INIT(serial)
	m_port = 1;
	m_baudrate = 1;
	m_tnc = 1;
	m_servercall = _T("");
	m_mycall = _T("");
	//}}AFX_DATA_INIT
	m_servercall = "NOCALL";
	m_mycall = "NOCALL";
	CWinApp* pApp = AfxGetApp();
	m_port = pApp->GetProfileInt("UITerm","port",12);
	m_servercall = pApp->GetProfileString("UITerm","server","NOCALL");   //get parameters from the registry
	m_mycall = pApp->GetProfileString("UITerm","callsign","NOCALL");
	m_baudrate = pApp->GetProfileInt("UITerm","baudrate",1200);
	m_tnc = pApp->GetProfileInt("UITerm","tnc",0);


}


void serial::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(serial)
	DDX_Control(pDX, IDC_EDIT2, m_mine);
	DDX_Control(pDX, IDC_EDIT1, m_server);
	DDX_Radio(pDX, IDC_RADIO1, m_port);
	DDX_CBIndex(pDX, IDC_COMBO1, m_baudrate);
	DDX_CBIndex(pDX, IDC_COMBO2, m_tnc);
	DDX_Text(pDX, IDC_EDIT1, m_servercall);
	DDV_MaxChars(pDX, m_servercall, 8);
	DDX_Text(pDX, IDC_EDIT2, m_mycall);
	DDV_MaxChars(pDX, m_mycall, 8);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(serial, CDialog)
	//{{AFX_MSG_MAP(serial)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// serial message handlers

void serial::OnOK() 
{



CWinApp* pApp = AfxGetApp();
extern CString server,callsign;


UpdateData();
m_server.GetWindowText(server);
server.MakeUpper();
m_mine.GetWindowText(callsign);
callsign.MakeUpper();

pApp->WriteProfileString("UITerm","server",server); //write parameters into the registry
pApp->WriteProfileString("UITerm","callsign",callsign);
pApp->WriteProfileInt("UITerm","port",m_port);
pApp->WriteProfileInt("UITerm","tnc",m_tnc);
pApp->WriteProfileInt("UITerm","baudrate",m_baudrate);	
	CDialog::OnOK();
}
