// InitSerial.cpp : implementation file
//

#include "stdafx.h"
#include "HTTPSockTest.h"
#include "InitSerial.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// InitSerial dialog


InitSerial::InitSerial(CWnd* pParent /*=NULL*/)
	: CDialog(InitSerial::IDD, pParent)

{
int baudrate;
char bd[6];
	
	//{{AFX_DATA_INIT(InitSerial)
	m_tnc = _T("");
	m_port = -1;
	m_call = _T("");
	m_ss = _T("");
	m_baudrate = _T("");
	m_proxy = _T("");
	m_digicall = _T("");
	m_digiss = _T("");
	//}}AFX_DATA_INIT
	m_ss = "0";
	m_call = "NOCALL";
	m_digicall = "      ";
	m_baudrate = "1200";
	CWinApp* pApp = AfxGetApp();
	m_port = pApp->GetProfileInt("HW2","port",12);
	m_call = pApp->GetProfileString("HW2","callsign","NOCALL");   //get parameters from the registry
	m_digicall = pApp->GetProfileString("HW2","digicallsign","      ");   //get parameters from the registry
	m_proxy = pApp->GetProfileString("HW2","proxy","");
	m_ss = pApp->GetProfileString("HW2","ssid","0");
	m_digiss = pApp->GetProfileString("HW2","digissid","0");
	baudrate = pApp->GetProfileInt("HW2","baudrate",1200);
	_itoa(baudrate,bd,10);
	m_baudrate = bd;
	m_tnc = pApp->GetProfileString("HW2","tnc","TAPR");


}


void InitSerial::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(InitSerial)
	DDX_Control(pDX, IDC_EDIT7, m_digissid);
	DDX_Control(pDX, IDC_EDIT6, m_digicallsign);
	DDX_Control(pDX, IDC_EDIT3, m_ctlproxy);
	DDX_Control(pDX, IDC_EDIT2, m_ssid);
	DDX_Control(pDX, IDC_EDIT1, m_callsign);
	DDX_CBString(pDX, IDC_COMBO2, m_tnc);
	DDX_Radio(pDX, IDC_RADIO1, m_port);
	DDX_Text(pDX, IDC_EDIT1, m_call);
	DDX_Text(pDX, IDC_EDIT2, m_ss);
	DDV_MaxChars(pDX, m_ss, 2);
	DDX_CBString(pDX, IDC_COMBO1, m_baudrate);
	DDX_Text(pDX, IDC_EDIT3, m_proxy);
	DDX_Text(pDX, IDC_EDIT6, m_digicall);
	DDX_Text(pDX, IDC_EDIT7, m_digiss);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(InitSerial, CDialog)
	//{{AFX_MSG_MAP(InitSerial)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// InitSerial message handlers

void InitSerial::OnOK() 
{
extern int baudrate;
extern int port;
extern  CString callsign,proxy,digicallsign;
extern CString ssid,digissid;
CWinApp* pApp = AfxGetApp();



UpdateData();
m_callsign.GetWindowText(callsign);
m_digicallsign.GetWindowText(digicallsign);
digicallsign.MakeUpper();
callsign.MakeUpper();
m_ctlproxy.GetWindowText(proxy);
m_ssid.GetWindowText(ssid);
m_digissid.GetWindowText(digissid);

baudrate = atoi(m_baudrate);
pApp->WriteProfileString("HW2","callsign",callsign); //write parameters into the registry
pApp->WriteProfileString("HW2","digicallsign",digicallsign);
pApp->WriteProfileString("HW2","proxy",proxy);
pApp->WriteProfileInt("HW2","port",m_port);
pApp->WriteProfileString("HW2","ssid",ssid);
pApp->WriteProfileString("HW2","digissid",digissid);
pApp->WriteProfileString("HW2","tnc",m_tnc);
pApp->WriteProfileInt("HW2","baudrate",baudrate);	
	CDialog::OnOK();
}
